def bissextile(a):
    return (a % 4 == 0 and (a % 100 != 0 or a % 400 == 0))


assert bissextile (2000)
assert bissextile (1984)
assert (not (bissextile(2023)))

def nb_jours_annee(a):
    if bissextile(a):
        return 366
    else:
        return 365

def nb_jours_mois(a, m):
    if bissextile(a) and m == 2:
        return 29
    jours = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]
    return jours[m-1] #attention, les mois vont de 1 à 12, les
                      #indices de tableau de 0 à 11

def nb_jours_date(a,m,j):
    total = j
    for i in range(1, m):
        total = total+ nb_jours_mois(a, i)
    return total-1


def nb_jours_entre(a1, m1, j1, a2, m2, j2):
    if a2 == a1:
        return nb_jours_date(a2, m2, j2) - nb_jours_date(a1, m1, j1)

    total = 0
    # on compte le nombre d'années entières :
    for i in range(a1 + 1, a2):
        total = total + nb_jours_annee(i)

    # on ajoute la dernière année incomplète :
    total = total + nb_jours_date(a2,m2,j2)

    if bissextile(a1):
        ja = 366
    else:
        ja = 365
    #On calcule le nombre de jours restant dans
    #l'année de la première date
    total = total + (ja - nb_jours_date(a1,m1,j1))
    return total


def ord_date (a1, m1, j1, a2, m2, j2):
    return a1 < a2 or (a1 == a2 and (m1 < m2 or (m1 == m2 and j1 <= j2)))

def verifie_date(a, m, j):
    return a >= 1600 and a <= 2100 and m >= 1 and m <= 12 and j >= 1 and j <= nb_jours_mois (a, m)

def trouve_intervalle_max(fichier):
    fd = open(fichier, "r")
    j_max = 0
    l_max = 0
    lignes = fd.readlines()
    l_val = 0
    fd.close()
    for i in range(len(lignes)):
        tab_d = lignes[i].strip().split(" ") #sépare selon l'espace
        if len(tab_d) == 2:
            d1 = tab_d[0]
            d2 = tab_d[1]
            tab_d1 = d1.split("/")
            tab_d2 = d2.split("/")
            if len(tab_d1) == 3 and len(tab_d2) == 3:
                try:
                    a1 = int(tab_d1[2])
                    m1 = int(tab_d1[1])
                    j1 = int(tab_d1[0])
                    a2 = int(tab_d2[2])
                    m2 = int(tab_d2[1])
                    j2 = int(tab_d2[0])
                    if verifie_date(a1, m1, j1) and \
                       verifie_date(a2, m2, j2) and \
                       ord_date(a1, m1, j1, a2, m2, j1):
                        jours = nb_jours_entre (a1, m1, j1, a2, m2, j1)
                        l_val = l_val + 1
                        if jours > j_max:
                            j_max = jours
                            l_max = i
                except:
                    pass
    print ("Intervale le plus long ligne", l_max, "de longueur", j_max)
    print (l_val, "lignes valides sur", len(lignes))
trouve_intervalle_max("dates.txt")
